PROGRAM UnXYD;

USES DOS, StrBlock;

CONST
    mpoint = 10;

VAR
    pstr, iname, oname, ext, current_path, new_path: ASCIIZ_string;
    srec: SearchRec;
    IOChain: pointer;
{
    prev: CHAR;
 }
    ibuf, obuf: ARRAY [0 .. 8191] OF CHAR;
    i, npoint: INTEGER;
    dt_d: DOUBLE;
    dt: LONGINT;

(*
FUNCTION IOCall(VAR f: TextRec; VAR p: pointer): WORD; INLINE(
    $5E/                {POP si}
    $07/                {POP es}
    $26/$FF/$1C         {CALL FAR es:[si]}
);


FUNCTION IOPatch(VAR f: TextRec): WORD;

    VAR i: INTEGER;
        curr: CHAR;

BEGIN
    IOPatch := IOCall(f,IOChain);
    WITH f DO BEGIN
        FOR i := BufPos TO Pred(BufPos+BufEnd) DO BEGIN
            curr := BufPtr^[i];
            IF (prev <> #13) AND (curr = #10) THEN
                BufPtr^[i] := #13;
            prev := curr;
        END;
    END;
END;
*)

PROCEDURE UnXYDIO(iname, oname: ASCIIZ_string);

    VAR ifile, ofile: TEXT;
        x, y, dx, dy: ARRAY [1 .. mpoint] OF LONGINT;
        i: INTEGER;
        t: LONGINT;

BEGIN
    Assign(ifile,iname);
    Assign(ofile,oname);
    SetTextBuf(ifile,ibuf);
    SetTextBuf(ofile,obuf);
    Reset(ifile);
    Rewrite(ofile);
{
    prev := #00;
    IOChain := TextRec(ifile).InOutFunc;
    TextRec(ifile).InOutFunc := @IOPatch;
 }
    t := 0;
    npoint := 0;
    WHILE NOT EOF(ifile) DO BEGIN
        i := 0;
        WHILE NOT EOLN(ifile) AND (i < mpoint) DO BEGIN
            Inc(i);
            Read(ifile,dx[i],dy[i]);
            IF i > npoint THEN BEGIN
                Inc(npoint);
                x[i] := 0;
                y[i] := 0;
            END;
            x[i] := x[i] + dx[i];
            y[i] := y[i] + dy[i];
        END;
        Readln(ifile);
        Write(ofile,t);
        FOR i := 1 TO npoint DO
            Write(ofile,#9,x[i],#9,y[i]);
        Writeln(ofile);
        t := t + dt;
    END;
    Close(ifile);
    Close(ofile);
END;


BEGIN
    iname := '';
    oname := '';
    dt_d  := 0;
    FOR i := 1 TO ParamCount DO BEGIN
        pstr := ParamStr(i);
        UpdateDoubleKeyword(dt_d,pstr,'/T:');
        IF Copy(pstr,1,1) <> '/' THEN BEGIN
            IF iname = '' THEN
                iname := pstr
            ELSE
            IF oname = '' THEN
                oname := pstr;
        END;
    END;
    IF dt_d <= 0 THEN
        dt_d := 6.866;
    dt := Round(1000.0*dt_d);
    IF oname = '' THEN
        oname := '.txy';

    IF Copy(oname,1,1) <> '.' THEN BEGIN
        UnXYDIO(iname,oname);
    END ELSE BEGIN
        ext := oname;
        GetDir(0,current_path);
        iname := FileInDir(iname);
        GetDir(0,new_path);
        FindFirst(iname,0,srec);
        WHILE DOSError = 0 DO BEGIN
            iname := FullPath(srec.Name);
            ChDir(current_path);
            oname := Concat(RootPath(srec.Name),ext);
            Writeln(iname,' ',oname);
            UnXYDIO(iname,oname);
            ChDir(new_path);
            FindNext(srec);
        END;
        ChDir(current_path);
    END;
END.
